
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>MFC子窗口和父窗口（SetParent,SetOwner） / iVAN</title>

    <meta name="description" content="MFC子窗口和父窗口（SetParent,SetOwner） 一.概念和区别 在windows系统中,每个窗口对象都对应有一个数据结构,形成一个list链表.系统的窗口管理器通过这个list来获取窗口信息和管理每个窗口.这个数据结构中有四个数据用来构建list,即child.sibling.parent.owner四个域.所以我们可以看到,窗口之间的关系有两种:owner-owned 关系和 parent-child关系.前者称之为拥有/被拥有关系,后者称之为父/子关系.在这篇文字中,我把owner窗口称之所有者窗口.换句话说,一个窗口在有一个父窗口(pa">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">MFC子窗口和父窗口（SetParent,SetOwner）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>一、概念和区别<br />
<br />在windows系统中，每个窗口对象都对应有一个数据结构，形成一个list链表。系统的窗口管理器通过这个list来获取窗口信息和管理每个窗口。这个数据结构中有四个数据用来构建list，即child、sibling、parent、owner四个域。<br />所以我们可以看到，窗口之间的关系有两种：owner-owned 关系和 parent-child关系。前者称之为拥有/被拥有关系，后者称之为父/子关系。在这篇文字中，我把owner窗口称之所有者窗口。换句话说，一个窗口在有一个父窗口（parent)的同时，还可能被不同的窗口拥有（owner)，也可以有自己的子窗口(child)。在MFC 的CWnd类中，所有者窗口保存在m_hWndOwner成员变量中，父窗口则保存在m_hParent中，但是这两个值并不一定和窗口对象数据结构中的值相对应。</p>
<p>窗口之间的关系，决定了窗口的外在表现。比如显示、销毁等。</p>
<p>如果一个窗口数据的owner域非NULL，则它和该窗口建立了owner-owned 关系，拥有关系决定了：<br />（1）被拥有的窗口永远显示在拥有它的那个窗口的前面；<br />（2）当所有者窗口最小化的时候，它所拥有的窗口都会被隐藏；<br />（3）当所有者窗口被销毁的时候，它所拥有的窗口都会被销毁。<br />需要注意的是，隐藏所有者窗口并不会影响它所拥有的窗口的可见状态。比如：如果窗口 A 拥有窗口B,窗口B拥有窗口C,则当窗口A最小化的时候，窗口B被隐藏，但是窗口 C还是可见。</p>
<p>如果一个窗口的parent域非NULL，则它和该窗口之间就建立了parent-child关系。父子决定了：<br />（1）窗口在屏幕上面的显示位置。父窗口提供了用来定位子窗口的坐标系统，一个子窗口只能显示在它的父窗口的客户区中，之外的部分将被裁减。这个裁减法则决定了如果父窗口不可见，则子窗口肯定不可见。如果父窗口移动到了屏幕之外，子窗口也一样。<br />（2）当父窗口被隐藏时，它的所有子窗口也被隐藏。<br />（3）父窗口被销毁的时候，它所拥有的子窗口都会被销毁。<br />注意！最小化父窗口不会影响子窗口的可见状态，子窗口会随着父窗口被最小化，但是它的WS_VISIBLE属性不会变。</p>
<p>Windows系统为什么要使用两种关系呢？这是为了更加灵活的管理窗口。举个例子：组合框（combobox)的下拉列表框（list box）可以超出组合框的父窗口的客户区，这样有利于显示，因此系统创建该list box的时候，是作为控制台窗口（desktop window）的子窗口，它的父窗口hWndParent是NULL，这样，list box的显示区域是限制在整个屏幕内，但是该list box的所有者却是组合框的第一个非子窗口祖先（比如对话框），当它的所有者窗口销毁后，该 list box自动销毁。</p>
<p>另外，窗口之间消息的传递也和窗口关系有关，通常，一个窗口会把自己的通知消息发送给它的父窗口，但不全是这样，比如，CToolBar发送通知消息给它的所有者窗口而不是父窗口。这样以来，就可以允许工具条作为一个窗口（比如一个 OLE 容器程序窗口）的子窗口的同时，能够给另一个窗口（比如in-place框架窗口）发送消息。至于某类窗口到底是把消息发送给谁，是父窗口还是所有者窗口，microsoft并没有明示。还有，在现场（in-place）编辑的情况下，当一个 server 窗口激活或者失效的时候，框架窗口所拥有的子窗口自动隐藏或者显示，这也是通过直接调用SetOwner函数实现的。</p>
<p>二、窗口类型的说明和限制</p>
<p>（1）控制台窗口（desktop window）。这是系统最早创建的窗口。可以认为它是所有 WS_OVERLAPPED 类型窗口的所有者和父窗口。Kyle Marsh在他的文章“Win32 Window Hierarchy and Styles”中指出，当系统初始化的时候，它首先创建控制台窗口，大小覆盖整个屏幕。所有其它窗口都在这个控制台窗口上面显示。窗口管理器所用的窗口list中第一个就是这个控制台。它的下一层窗口叫做顶级窗口（top-level），顶级窗口是指所有非child、没有父窗口，或者父窗口是desktop的窗口，它们没有WS_CHILD属性。</p>
<p>（2）WS_OVERLAPPED类型的窗口可以显示在屏幕的任何地方。它们的所有者窗口是控制台。</p>
<p>Overlapped 类型的窗口属于顶级窗口，一般作为应用程序的主窗口。不论是否给出了WS_CAPTION、WS_BORDER属性，这类窗口创建后都有标题栏和边框。Overlapped窗口可以拥有其它顶级窗口或者被其它顶级窗口所拥有。所有overlapped窗口都有WS_CLIPSIBLINGS属性。系统可以自动设置 overlapped窗口的大小和初始位置。</p>
<p>当系统 shuts down的时候，它将销毁所有overlapped类型的窗口。</p>
<p>（3）WS_POPUP类型的窗口可以显示在屏幕任何地方，它们一般没有父窗口，但是如果明确调用SetParent，这类窗口也可以有父窗口。</p>
<p>WS_POPUP类型的窗口的所有者是在CreateWindow函数中通过设置hWndParent参数给定的，如果hWndParent不是子窗口，则该窗口就成为这个新的弹出式窗口的owner，否则，系统从hWndParent的父窗口向上找，直到找到第一个非子窗口，把它作为该弹出窗口的owner。当owner窗口销毁的时候，系统自动销毁这个弹出窗口。</p>
<p>Pop-up类型的窗口也属于顶级窗口，它和 overlapped 窗口的主要区别是弹出式窗口不需要有标题栏，也不必有边框。弹出式可以拥有其它顶级窗口或者被拥有。所有弹出式窗口也都有 WS_CLIPSIBLINGS属性。</p>
<p>（4）所有者窗口（owner)只能是 overlapped 或者 pop-up 类型的窗口，子窗口不能是所有者窗口，也就是说子窗口不能拥有其它窗口。</p>
<p>overlapped 或者 pop-up 类型的窗口在拥有其它窗口的同时，也可以被拥有。</p>
<p>在使用CreateWindowEx创建 WS_OVERLAPPED 或者 WS_POPUP类型的窗口时，可以在 hwndParent 参数中给出它的所有者窗口的句柄。如果 hwndParent 给出的是一个child 类型的窗口句柄，则系统自动将新创建窗口的所有权交给该子窗口的顶级父窗口。在这种情况下，参数hwndParent被保存在新建窗口的parent域中，而它的所有者窗口句柄则保存在owner域中。</p>
<p>（5）缺省情况下，对话框和消息框属于 owned 窗口，除非在创建它们的时候明确给出了WS_CHILD属性，（比如对话框中嵌入对话框的情形）<br />否则由系统负责给它们指定owner窗口。需要注意的是，一旦创建了owned类型的窗口，就无法再改变其所有关系，因为WIN32没有没有提供改变窗口所有者的方法。</p>
<p>而且在Win32中，由于有多线程的存在，所以要注意保证父子窗口或者owner/owned 窗口要同属于一个线程。</p>
<p>（6）对于 WS_CHILD类型的窗口，它的父窗口就是它的所有者窗口。一个子窗口的父窗口也是在CreateWindow函数中用hWndParent参数指定的。子窗口只能在父窗口的客户区中显示，并随父窗口一起销毁。<br />子窗口必须有一个父窗口，这是它和overlapped 以及 pop-up 窗口之间的主要区别。父窗口可以是顶级窗口，也可以是其它子窗口。</p>
<p>三、几个相关函数的说明</p>
<p>（1）获取/设置所有者窗口</p>
<p>win32 API提供了函数GetWindow函数（GW_OWNER 标志）来获取一个窗口的所有者窗口句柄。<br />GetWindow(hWnd, GW_OWNER)永远返回窗口的所有者(owner)。对于子窗口，函数返回 NULL，因为它们的父窗口就相当于所有者（注意，是“相当于”）。因为Windows系统没有维护子窗口的所有者信息。</p>
<p>MFC中则是通过如下函数得到所有者窗口指针：<br />_AFXWIN_INLINE CWnd* CWnd::GetOwner() const<br />{ return m_hWndOwner != NULL ? CWnd::FromHandle(m_hWndOwner) : GetParent(); }<br />从上述代码我们可以看出，它返回的值和GetWindow返回的有所区别，如果当前窗口没有owner，那么将返回它的父窗口指针。</p>
<p>但是Windows没有提供改变窗口所有者的方法。MFC中则提供了改变所有者的方法：<br />_AFXWIN_INLINE void CWnd::SetOwner(CWnd* pOwnerWnd)<br />{ m_hWndOwner = pOwnerWnd != NULL ? pOwnerWnd-&gt;m_hWnd : NULL; }</p>
<p>另外，mfc还提供了CWnd::GetSafeOwner( CWnd* pParent, HWND* pWndTop );函数，可以用来得到参数pParent的第一个非child属性的父窗口指针。如果这个参数是NULL，则返回当前线程的主窗口(通过AfxGetMainWnd得到)。框架经常使用这个函数查找对话框或者属性页的所有者窗口。</p>
<p>（2）获取/设置父窗口</p>
<p>WIN32 API给出了函数GetParent和SetParent。而mfc也是完全封装了这两个函数：</p>
<p>_AFXWIN_INLINE CWnd* CWnd::SetParent(CWnd* pWndNewParent)<br />{ ASSERT(::IsWindow(m_hWnd)); return CWnd::FromHandle(::SetParent(m_hWnd,<br />pWndNewParent-&gt;GetSafeHwnd())); }</p>
<p>_AFXWIN_INLINE CWnd* CWnd::GetParent() const<br />{ ASSERT(::IsWindow(m_hWnd)); return CWnd::FromHandle(::GetParent(m_hWnd)); }</p>
<p>对于SetParent，msdn里面说明了父子窗口必须是同一个进程的。但是由于窗口句柄是系统全局唯一的，不属于同一个进程的情况下，也可以成功调用，但是后果未知。<br />GetParent的返回值比较复杂，对于overlapped类型的窗口，它返回0，对于WS_CHILD类型，它返回其父窗口，对于WS_POPUP类型，它返回其所有者窗口，如果想得到创建它时所传递进去的那个hwndParent参数，应该用GetWindowWord(GWW_HWNDPARENT)函数。</p>
<p>（3）GetWindowWord(hWnd, GWW_HWNDPARENT)返回一个窗口的父窗口，如果没有，则返回其所有者。</p>
<p>（4）上面谈到，当一个owner窗口被最小化后，系统自动隐藏它所拥有的窗口。当owner窗口被恢复的时候，系统自动显示它所拥有的窗口。在这两种情况下，系统都会发送（send）WM_SHOWWINDOW消息给被拥有的窗口。某些时候，我们可能需要隐藏 owned窗口，但并不想最小化其所有者窗口，这时候，可以通过ShowOwnedPopups函数来实现，该函数设置或者删除当前窗口所拥有的窗口的WS_VISIBLE属性，然后发送WM_SHOWWINDOW消息更新窗口显示</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:29:10</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/list/" title="list">list</a>, <a href="https://www.iamivan.net/tag/mfc/" title="mfc">mfc</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%bb%93%e6%9e%84/" title="数据结构">数据结构</a>, <a href="https://www.iamivan.net/tag/%e6%8e%a7%e5%88%b6%e5%8f%b0/" title="控制台">控制台</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>MFC子窗口和父窗口（SetParent,SetOwner）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvLw5z.html" rel="bookmark">JavaScript实际应用：子窗口和父窗口交互</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				javascript|父窗口|交互|子窗口 最近项目开发中需要子窗口和父窗口交互的内容,基本上无非就是把子窗口的信息传递给父窗口,并且关闭自己等等,或者是父窗口把自己的信息传递给子窗口等等. 1.父窗口传递信息给子窗口 看代码实例:&lt;script language=javascript&gt; function outPut(){ //获取父窗口的文本信息赋值给text var text = document.abc.text.value; //打开子窗口,并且把操作句柄赋值给win变量,以下所有操			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze7EB0M.html" rel="bookmark">swt-java中窗口隐藏与现显示&comma;&lpar;子窗口回到父窗口&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java中窗口隐藏与现显示,(子窗口回到父窗口) public static Shell shlIvmsv;//声明一个窗口管理器 创建一个窗口 J1 ...... ClientDemo.GetClientDemo().playMain();//创建另外一个窗口 J2 shlIvmsv.setVisible(false);//隐藏主界面 J1 ....... 然后我在 J2对应的程序中, ...... if(Main.shlIvmsv!=null){//显示PC主界面 Main.shl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYnDLb.html" rel="bookmark">javascript子窗口刷新父窗口程序代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				htm代码如下  代码如下 复制代码 &quot;&lt;html&gt; &lt;body&gt; &lt;a href=htm onclick=&quot;window.open('htm')&quot;&gt;new&lt;/a&gt; &lt;/body&gt; &lt;/html&gt; htm代码如下  代码如下 复制代码 &quot;&lt;html&gt; &lt;body&gt; &lt;a href=# onclick=&quot;opener.location.href='http:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0NBNp.html" rel="bookmark">JavaScript子窗口调用父窗口变量和函数的方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了JavaScript子窗口调用父窗口变量和函数的方法.分享给大家供大家参考.具体如下: 示例1:子窗口是新打开的窗口 父窗口: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&quot;&gt; &lt;html xmlns=&quot; http://www.w3.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0YD06p.html" rel="bookmark">mfc窗口，父窗口parentwindow，所有者窗口ownerwindow 区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. parent:创建者,owner:所有者 小玉的父母生下小玉,养到8岁,卖给贾府当丫头小玉的父母是parent,贾府是owner 二. 1.Pop-up窗口: 一个弹出窗口是必须具有WS_POPUP属性的窗口,弹出窗口只能是一个Top-Level窗口,不能是子窗口,弹出窗口多用于对话框和消              息框,也可以用于应用程序的主窗口, 弹出窗口可以不必具有标题栏 2.Overlapped窗口: 一个重叠窗口是一个必须具有WS_OVERLAPPED属性的窗口,也就是一个重叠窗			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bolvagM.html" rel="bookmark">window&period;showModalDialog 子窗口给父窗口赋值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				A.使用window.returnValue给父窗口传值,然后根据值判断是否刷新.       在window.showModalDialog窗口页面中用window.returnValue方式设置返回值:       比如:window.returnValue='refresh';        B.在写window.showModalDialog弹出窗口函数时,定义个变量,然后根据变量值进行操作父窗口的操作:    例如:var winPar=window.showModalDialog(u			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNJ7ep.html" rel="bookmark">子窗口、父窗口和Silverlight之间的相互调用&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				其实,他们之间的调用还是很简单的~ 基础篇 一.父页面调用子页面中的JS 我们先创建一个子窗体 复制代码 代码如下: var win $(function () { Root = $('#Root').val();//设置根目录 }); function OpenPlayer(id, type, add) { //这里是用来限制同一个窗口只能弹出一次的 //其实就算不做限制,只要window.open参数中的name相同,就不会重复打开 //window.open中的参数可以参考别的文章,有很多			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mlmd9Dp.html" rel="bookmark">JS 子窗口操作父窗口实例详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.从子窗口中往父窗口传值 如父页面有一个控制的id是choosedProvider,那么这样可以把值传给父页面:  代码如下 复制代码 opener.document.getElementById(&quot;choosedProvider&quot;]).value=&quot;Tom&quot;; 2.从父窗口传值给子窗口,如子窗口中有id为T的控件,此时可以用如下传值:  代码如下 复制代码 &lt;script&gt; var newWindow; function openWindow(url			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlADPnp.html" rel="bookmark">jquery 子窗口操作父窗口的代码&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				$(&quot;#父窗口元素ID&quot;,window.parent.document)...就行了 js 版本 view sourceprint?1.window.parent.document.getElementById()			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9ze0AOp.html" rel="bookmark" class="title">提高应用商店曝光度的经验分享</a>
					<div>
						我从与iPhone应用开发商和智能手机安全公司Lookout共事经历中学到的重要经验是应用商店之间存在差异,以及如何通过较小营销投入发挥应用排名的最大作用.我在Android Market领域经验更丰 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYd8rb.html" rel="bookmark" class="title">书籍中的一个小样章-Java并发编程AQS原理浅析</a>
					<div>
						AQS的全称为(AbstractQueuedSynchronizer),这个类也是在java.util.concurrent.locks下面.这个类似乎很不容易看懂,因为它仅仅是提供了一系列公共的方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0De0M.html" rel="bookmark" class="title">Photoshop图片创意合成教程&colon;潮流真人插画</a>
					<div>
						潮流真人插画合成需要较强的美术功底,用到的颜色及素材较多.需要完美的搭配起来,是要花费很多功夫的.作者介绍的仅仅是思路和操作方法,实际运用中还需要自己多去思考,做出较高水准的作品.原图 最终效果    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wD28p.html" rel="bookmark" class="title">Sql Server代码设置主键并自动生长</a>
					<div>
						  新建一张数据表,将Userid设为主键并自动增长 create table T_UserLogin(UserId int not null primary key identity(1,1),Us ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2o3Vp.html" rel="bookmark" class="title">用Excel制作工资条的方法</a>
					<div>
						用Excel制作工资条的方法 如何使用Excel进行工资条的制作,也许有些网友使用已经很长时间了,但如何更快更好的做出漂亮的工资条,看看作者的方法吧. &quot;小问题难倒老财务&quot;,也许你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bad0Qwz.html" rel="bookmark" class="title">win7系统右键菜单添加EFS快速加密选项的技巧</a>
					<div>
						正常情况下,用户需要打开文件或文件夹属性,在常规-高级中勾选&quot;加密内容以便保护数据&quot;,比较繁琐. 操作步骤: 1.按Win+R打开运行,输入regedit回车打开注册表编辑器; 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKP4KM.html" rel="bookmark" class="title">用好WIN7必须记住的70个技巧</a>
					<div>
						  1. 电脑守卫 我很少让其他人使用我的电脑,因为我怕他们会把它弄的乱七八糟的,但是看起来,微软已经替我考虑到这一点并且顺便解决了这个问题.PC Safeguard不会让任何人把你电脑的设置弄乱,因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZd1jkM.html" rel="bookmark" class="title">电脑哪个盘影响网速？</a>
					<div>
						  网速很慢的几个原因 原因一:本地病毒.木马的错 这是许多网友第一时间想到的答案.不错,感染某些病毒.木马的确会造成网速很慢.但是,又有多少网友会去验证呢? 验证第一步:用反病毒软件全盘查毒.这是一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxW9wPb.html" rel="bookmark" class="title">无法在XP系统的文件窗口中实现后退怎么办？</a>
					<div>
						  1.首先,咱们需要将鼠标移动到XP文件夹窗口上方的菜单栏中,然后随便的找一个空白处点击鼠标右键,在下滑菜单中选择锁定工具栏,将其勾选上. 2. 之后,咱们勾选&quot;标准按钮&quot;,完成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdL0kM.html" rel="bookmark" class="title">java中的字符数组反序-java中怎么将一个字符数组反序</a>
					<div>
						问题描述 java中怎么将一个字符数组反序 新手java中怎么将一个字符数组反序,不要new数组,只能使用一个字符数组,三克油 解决方案 可以用Collection.reverse(list)呀,先把 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze62vjb.html" rel="bookmark" class="title">利用百度地图JSAPI生成h7n9禽流感分布图实现代码&lowbar;javascript技巧</a>
					<div>
						下图为使用百度地图JSAPI生成的H7N9感染分布图示例,其中的数据来自新华网(4.8号),截图如下: 使用的功能列表如下: 1.自定义版权控件功能,即(1)对应的数据来源部分,代码如下: 复制代码  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwdgjM.html" rel="bookmark" class="title">iOS系统声音列表</a>
					<div>
						iOS系统声音列表   效果   说明 1. 点击cell就能发出声音 2. 只需要给出声音编号,就可以,非常简单易用   源码 https://github.com/YouXianMing/Syst ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdElQ3z.html" rel="bookmark" class="title">王祥芸的离职是她基于个人发展的选择</a>
					<div>
						本报讯(记者 刘宇鑫)针对土豆网首席运营官王祥芸离职一事,土豆网昨日发表声明表示,王祥芸的离职是她基于个人发展的选择,目前优酷.土豆管理层和员工都很稳定,合并工作进展顺利.由于王祥芸也是这两家视频网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7wEWz.html" rel="bookmark" class="title">认清老板，职场少吃亏</a>
					<div>
						中国市场是以中小企业为主体的市场,许多步入职场的新人只能屈就于没有前景的企业,经过努力工作后没能得到公平的回报是常有的事,有些企业和老板根本就不值得员工去为他们卖命,但作为职场新人既有无奈也有无知的因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr6qrM.html" rel="bookmark" class="title">阿里感悟（十八）- 应届生Review</a>
					<div>
						本周和应届生做了下Review.在阿里应届生被称为青年近卫军,因为他们是有能力有环境快速成长为独当一面的人才.第一次Review的目的,短期目标是通过入职后的转正面试,长期目标是个人的快速成长. 应届 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NakjM.html" rel="bookmark" class="title">数字化转型加速金融服务业四大变革</a>
					<div>
						&quot;这是最好的时代,这是最坏的时代,我们面前应有尽有,我们面前一无所有--&quot; -- 狄更斯在&lt;双城记&gt;中描绘了18世纪末由蒸汽机驱动的第一次工业革命,带给欧洲社会的彷徨与 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrXDQM.html" rel="bookmark" class="title">ViewPager和FragmentPagerAdapter适配器实现微信tab界面 （可实现左右拖动切换界面）</a>
					<div>
						效果: 一.主要步骤: 1.创建工程项目,建立四个Fragment.java文件(如 weixin_Fragment.java)  2.建立四个tab.xml文件(如:tab01.xml) 3.创建t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwXK1p.html" rel="bookmark" class="title">windows-请教下：在JNI某类构造方法里添加了PdhAddCounter，返回值一直不正确！</a>
					<div>
						问题描述 请教下:在JNI某类构造方法里添加了PdhAddCounter,返回值一直不正确! 在JNI某个类的构造方法里添加了PdhAddCounter(query_TEXT(&quot;&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlZA5b.html" rel="bookmark" class="title">请问xslt中如何值如何作为连接参数</a>
					<div>
						问题描述 请问我要实现如下功能,该怎么写?&lt;a href=&quot;view.jsp?x=&lt;xsl:value-of select=&quot;X&quot;/&gt;&amp;y=&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RyX3b.html" rel="bookmark" class="title">为什么添加了图片以后整个类保存错误 ！！跪求答案</a>
					<div>
						问题描述 先是主类里面的保存函数 if(e.getSource()==saveManul){startMakeManul.setVisible(false);JFileChooserchooser=n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RayQb.html" rel="bookmark" class="title">如何在父窗体的ListView中获取子窗体中datagridview中的值</a>
					<div>
						问题描述 如何在父窗体的ListView中获取子窗体中datagridview中的值?详细啊本人只是初学者 解决方案 解决方案二:datagridview弄成public					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYkQjp.html" rel="bookmark" class="title">小语种、大数据，这些新专业要火了</a>
					<div>
						日前,教育部在官网上公布了2015年度普通高等学校本科专业备案和审批结果的通知.浙江高校新增70个备案本科专业和7个审批本科专业,后者是国家控制布点专业. 其中,温州大学新增了5个专业,分别是小学教育 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKkGXb.html" rel="bookmark" class="title">净水器被检出砷超标松下开始召回</a>
					<div>
						昨日(5月31日),松下开始召回型号为TK38MRF且生产日期为2009年1月29日.2009年3月16日和2009年4月22日的净水器. 一天之前的5月30日,卫生部发布 &lt;关于公布不合格涉水 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7N3AM.html" rel="bookmark" class="title">上海夏日通讯 最正规的手机商城 只专注精品</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   上海夏日通讯是上海最正规的手机商城,在上海地区可谓是家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4eJeLb.html" rel="bookmark" class="title">苹果iPad版iOS7系统截图曝光 与iPhone功能一致</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   Apple的新一代手机操作系统 iOS 7 明显是赶工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRZNKp.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;实体类&rdquo;可不可以动态添加&OpenCurlyDoubleQuote;字段&rdquo;和&OpenCurlyDoubleQuote;属性&rdquo;</a>
					<div>
						问题描述 &quot;实体类&quot;可不可以动态添加&quot;字段&quot;和&quot;属性&quot;???比如一个实体类,如下:publicclassEnergyTargetModel{ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq70LKz.html" rel="bookmark" class="title">JDBC里的return&lowbar;generated&lowbar;keys问题，在SSH整合框架中怎么解决？？</a>
					<div>
						问题描述 代码如下:String sql=&quot;insert into article values(null,0,?,?,?,now(),0)&quot;; conn=DB.getConn() ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12d2rp.html" rel="bookmark" class="title">musl 0&period;8&period;5发布 Linux系统标准程序库</a>
					<div>
						musl 是一款基于Linux系统标准库的新实现.它的特点是轻量级.快速.简单.免费和安全.它用于代替系统标准库的musl构建程序的打包器(如glibc),可以直接评估库,并与它建立紧凑的静态链接.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeqalM.html" rel="bookmark" class="title">拥抱Windows上的Hadoop&mdash;&mdash;HDInsight吧</a>
					<div>
						大数据是如此的真实,离我们越来越近,你不再需要繁复的Linux操作,拥抱Windows上的Hadoop--HDInsight吧.HDInsight是一个Windows平台上,100%兼容http:// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqByvb.html" rel="bookmark" class="title">《PHP、MySQL和Apache入门经典（第5版）》一一2&period;8 MySQL权限系统简介</a>
					<div>
						2.8 MySQL权限系统简介 PHP.MySQL和Apache入门经典(第5版) MySQL权限系统总是起作用的.当你第一次尝试连接MySQL服务器的时候,并且对于每一个后续的动作,MySQL都会检 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
